local exception_surfaces_list = {'NiceFill'}

function enigma (data)
  if not global then global = {} end
  if not global.enigma then global.enigma = {} end
  local e = data and data.e or global.enigma.e or 123
  local d = data and data.d or global.enigma.d or 6
  local w = (e^(1/2))
  e =  (w - math.floor (w)) * 10^d
  global.enigma.e = e
  return (math.floor (e))
end

function is_water (position, seed, hight)
  local x = position.x
  local y = position.y
  local par_x = 0
  local par_y = 0

  local periode = {5*2, 11*2, 23*2, 47*2, 97*2, 211*2, 317*2}
  local seed = seed or 12
  enigma({e = seed})
  
  local max_amp= 0
  for i, per in pairs (periode) do
    local amp = per * 0.98 ^ (i)
    max_amp = max_amp + amp
    par_x = par_x + amp * (math.sin ((x+enigma()) / (per/6.283)) * math.cos ((y+enigma()) / ((per)/6.283)))
    par_y = par_y + amp * (math.cos ((y+enigma()) / (per/6.283)) * math.sin ((x+enigma()) / ((per)/6.283)))
  end
  local vector = (par_x/max_amp)^2 * (par_y/max_amp)^2

  local hight = hight or 0.00003

  if vector < (hight) then
    return true
  else
    return false
  end
end

function old_is_water (position)
  local sd_x = {999671, 999683, 999721, 999727, 999749, 999763, 999769, 999773, 999809, 999853}
  local sd_y = {999863, 999883, 999907, 999917, 999931, 999953, 999959, 999961, 999979, 999983}
  local periode = {1, 3, 7, 15, 31, 63, 127, 255, 511, 1023}
  local x = position.x
  local y = position.y
  local par_x = 0
  local par_y = 0
  local max_amp= 0
  for i, per in pairs (periode) do
    local amp = per * 0.98 ^ (i)
    max_amp = max_amp + amp
    par_x = par_x + (amp * math.sin ((x+sd_x[i]*0.13) / ((per)/6.3)) * math.cos ((y+sd_y[11 - i]*0.17) / ((per)/6.3)))
    par_y = par_y + (amp * math.cos ((y+sd_x[i]*0.18) / ((per)/6.3)) * math.sin ((x+sd_y[11 - i]*0.21) / ((per)/6.3)))
  end
  local vector = (par_x/max_amp)^2 * (par_y/max_amp)^2
  if (vector > (0.1) and vector < (0.108))
    or (vector > (0.01) and vector < (0.011))
    or (vector < (0.000003))
    then
    return true
  else
    return false
  end
end

function is_value_in_list (value, list)
  for i, v in pairs (list) do
    if value == v then
      return true
    end
  end
  return false
end

script.on_configuration_changed(function(data)
  if not global then global = {} end
  if not global.is_old_version then global.is_old_version = true end
  if not global.version then global.version = 'version_01' end
  log ('on_configuration_changed: '..global.version)
end)


script.on_event(defines.events.on_chunk_generated, function(event)
  local surface = event.surface
  
  if is_value_in_list (surface.name, exception_surfaces_list) then return end
  
  if not global then global = {} end
  if not global.is_old_version then global.is_old_version = false end
  if not global.version then 
    global.version = 'version_03'
    log ('now version is: '..global.version)
  end

  local area = event.area
  
  local set_tiles = {}
  local version = global.version
  for y = area.left_top.y, area.right_bottom.y do
    for x = area.left_top.x, area.right_bottom.x do
      local position = {x = x, y=y}
      
      if version == 'version_01' and old_is_water(position) then
        if is_water(position, 31, 0.00005) then
          set_tiles[#set_tiles+1] = {name = 'ford', position = position}
        else
          set_tiles[#set_tiles+1] = {name = 'water', position = position}
        end
      end      
      
      if version == 'version_02' and is_water (position, 34) then
        if is_water(position, 31, 0.00005) then
          set_tiles[#set_tiles+1] = {name = 'ford', position = position}
        else
          set_tiles[#set_tiles+1] = {name = 'water', position = position}
        end
      end
          
      if version == 'version_03' and is_water (position, 41) then
        if is_water(position, 39, 0.00005) then
          set_tiles[#set_tiles+1] = {name = 'ford', position = position}
        else
          set_tiles[#set_tiles+1] = {name = 'water', position = position}
        end
      end
    
    end
  end
  if #set_tiles > 0 then
    surface.set_tiles(set_tiles, true)
  end
end)


function printAll(text)
  for i in pairs (game.players) do
    game.players[i].print(text)
  end
end

-- /c
local surface = game.surfaces['nauvis']
local cliffs = surface.find_entities_filtered{name='cliff'}
for i, cliff in pairs (cliffs) do
  surface.create_entity{name='point', position=cliff.position}
  log('clif_position = '..serpent.line(cliff.position))
end